/* CURVEFIT.H    3/13/91   BY MILTON WATTS   */

typedef struct {
	char id[20];
	char name[20];
	char units[6];
	int n1,p1;
	double m1,f01;
	int n2,p2;
	double m2,f02;
	double *c;
	double value;
	double span,zero;
	double tmin,tmax;
	double pmin,pmax;
	char date[20];
	char model[20];
} cfrec;

typedef struct {
	char name[20];
	char units[10];
	char id[20];
} colLabel;

char *fgetl(char *s, int n, FILE *fp);
void store_cf(FILE *fp, cfrec *cf);
int count_lines (FILE * fp);
int read_header(FILE *fp, char *row1, colLabel *cl, int nCols );
int store_header(FILE *fp, char *row1, colLabel *cl, int nCols );
int read_data(FILE *fp, double *cd[], int nCols);
int store_data(FILE *fp, double *cd[], int nCols, int nPts);

void stripQuotes(char *dest, char *src);
void dosextension (char *file, char *ext);
FILE *outfopen(char *file, char *ext);
double * dalloc (double **x, int npts);
int getFileDate(char *dest, FILE *fp);
void getRange(double *rmin, double *rmax, double *dptr, double rsln, int npts);

void do_prescale(
		double *xp, double *x, int type, double m, double f0, int npts);
int do_ref_prescale(double *xp, double *x, double *ref,
				int type, double m, double f0, int npts);
double prescale(double x, int type, double m, double f0);

int polyfit(double *x, double *y, double *z, double *r,
			double *c, int n, int s1, int s2);
int alloctemps(double **a, double **b[], double **d, double **f[],
		int n, int s);
void freetemps(double *a, double *b[], double *d, double *f[],
		int n,int s);
void dopowers(double *f[], double *x, double *y, int n, int s1, int s2, int s);
void matmult_12(double *a, double * b, double *c[], int npts, int s);
void matsub( double *a, double *b, double *c, int n);
void matmult_21 ( double * r, double *f[], double *c, int npts, int s);
void crossterms( double *bi[], double *f[], int n, int s);
int solve(double *a, double *b[], double *c, double *d, int s);
